/*
 * SpiderControl.java
 *
 * Created on September 20, 2004, 3:48 PM
 */
import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;
import java.util.*;
import java.net.*;
/**
 * User interface to conduct web searches with the Spider object
 * @author Mark Pendergast
 */
public class SpiderControl extends javax.swing.JFrame implements VerifierListener{
    
    /** Creates new form SpiderControl */
    public SpiderControl() {
        initComponents();
        setSize(650,600);
        setTitle("Web Spider Demo");
      //
      // center the frame on the screen
      //
      Dimension oursize = getSize();
      Dimension screensize = Toolkit.getDefaultToolkit().getScreenSize();
       
       int x = (screensize.width - oursize.width)/2;
       int y = (screensize.height- oursize.height)/2;
       x = Math.max(0,x);  // keep the corner on the screen
       y = Math.max(0,y);  //
       setLocation(x,y); 
       
      DefaultMutableTreeNode root = new DefaultMutableTreeNode("Empty"); 
      DefaultTreeModel treeModel = new DefaultTreeModel(root);  // create a tree model with a root
      searchTree.setModel(treeModel);

       URL iconurl = getClass().getResource("SPIDERWEB.gif"); // capitalization counts on the filename
       if(iconurl != null)
       {
        ImageIcon ic = new ImageIcon(iconurl);
        setIconImage(ic.getImage());    // tell the frame to set is as its icon
       }

    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        toolBar = new javax.swing.JPanel();
        startButton = new javax.swing.JButton();
        stopButton = new javax.swing.JButton();
        clearMessageButton = new javax.swing.JButton();
        viewButton = new javax.swing.JButton();
        exitButton = new javax.swing.JButton();
        centerPane = new javax.swing.JTabbedPane();
        formTab = new javax.swing.JPanel();
        siteLabel = new javax.swing.JLabel();
        siteField = new javax.swing.JTextField();
        depthLabel = new javax.swing.JLabel();
        depthField = new javax.swing.JTextField();
        keywordLabel = new javax.swing.JLabel();
        keywordPane = new javax.swing.JScrollPane();
        keywordArea = new javax.swing.JTextArea();
        domainLabel = new javax.swing.JLabel();
        domainPane = new javax.swing.JScrollPane();
        domainList = new javax.swing.JList();
        startingLabel = new javax.swing.JLabel();
        errorLabel = new javax.swing.JLabel();
        jTextArea1 = new javax.swing.JTextArea();
        startSiteField = new javax.swing.JTextField();
        treeTab = new javax.swing.JPanel();
        searchTreePane = new javax.swing.JScrollPane();
        searchTree = new javax.swing.JTree();
        pageStatistics = new javax.swing.JTextArea();
        messageTab = new javax.swing.JScrollPane();
        messageArea = new javax.swing.JTextArea();
        statusLabel = new javax.swing.JLabel();

        setBackground(new java.awt.Color(153, 153, 255));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        toolBar.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        toolBar.setBackground(new java.awt.Color(204, 204, 204));
        startButton.setFont(new java.awt.Font("Arial", 1, 11));
        startButton.setText("Start Search");
        startButton.setToolTipText("Start the search");
        startButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startButtonActionPerformed(evt);
            }
        });

        toolBar.add(startButton);

        stopButton.setFont(new java.awt.Font("Arial", 1, 11));
        stopButton.setText("Stop Search");
        stopButton.setToolTipText("Stop the search that is in progress");
        stopButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stopButtonActionPerformed(evt);
            }
        });

        toolBar.add(stopButton);

        clearMessageButton.setFont(new java.awt.Font("Arial", 1, 11));
        clearMessageButton.setText("Clear message area");
        clearMessageButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearMessageButtonActionPerformed(evt);
            }
        });

        toolBar.add(clearMessageButton);

        viewButton.setFont(new java.awt.Font("Arial", 1, 11));
        viewButton.setText("View Selected Web Page");
        viewButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewButtonActionPerformed(evt);
            }
        });

        toolBar.add(viewButton);

        exitButton.setFont(new java.awt.Font("Arial", 1, 11));
        exitButton.setText("Exit");
        exitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitButtonActionPerformed(evt);
            }
        });

        toolBar.add(exitButton);

        getContentPane().add(toolBar, java.awt.BorderLayout.NORTH);

        centerPane.setBorder(new javax.swing.border.EtchedBorder());
        formTab.setLayout(null);

        formTab.setBackground(new java.awt.Color(204, 204, 204));
        siteLabel.setText("Maximum number of sites to visit : ");
        formTab.add(siteLabel);
        siteLabel.setBounds(20, 30, 250, 15);

        siteField.setColumns(8);
        siteField.setText("100");
        siteField.setInputVerifier(new IntegerVerifier(this,false,1,10000)
        );
        formTab.add(siteField);
        siteField.setBounds(260, 30, 70, 21);

        depthLabel.setText("Maximum search depth : ");
        formTab.add(depthLabel);
        depthLabel.setBounds(20, 80, 230, 15);

        depthField.setColumns(8);
        depthField.setText("10");
        depthField.setInputVerifier(new IntegerVerifier(this,false,1,10000)
        );
        formTab.add(depthField);
        depthField.setBounds(260, 80, 70, 21);

        keywordLabel.setText("Keywords or phrases (one to a line) :");
        formTab.add(keywordLabel);
        keywordLabel.setBounds(20, 110, 220, 15);

        keywordArea.setColumns(20);
        keywordPane.setViewportView(keywordArea);

        formTab.add(keywordPane);
        keywordPane.setBounds(260, 110, 170, 140);

        domainLabel.setText("Domains to search : ");
        formTab.add(domainLabel);
        domainLabel.setBounds(30, 270, 120, 15);

        domainList.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "<any>", ".com", ".edu", ".gov", ".int", ".mil", ".net", ".org", ".us", ".ca" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        domainList.setSelectedIndex(0);
        domainPane.setViewportView(domainList);

        formTab.add(domainPane);
        domainPane.setBounds(260, 270, 170, 60);

        startingLabel.setText("Portal (starting site): ");
        formTab.add(startingLabel);
        startingLabel.setBounds(30, 340, 120, 15);

        errorLabel.setForeground(new java.awt.Color(255, 51, 51));
        errorLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        errorLabel.setText("  ");
        formTab.add(errorLabel);
        errorLabel.setBounds(30, 395, 400, 20);

        formTab.add(jTextArea1);
        jTextArea1.setBounds(240, 360, 0, 17);

        startSiteField.setColumns(80);
        formTab.add(startSiteField);
        startSiteField.setBounds(150, 340, 320, 21);

        centerPane.addTab("Search Parameters", formTab);

        treeTab.setLayout(new java.awt.BorderLayout());

        searchTreePane.setBackground(new java.awt.Color(204, 204, 204));
        searchTreePane.setBorder(new javax.swing.border.EtchedBorder());
        searchTree.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                searchTreeSelectionChange(evt);
            }
        });

        searchTreePane.setViewportView(searchTree);

        treeTab.add(searchTreePane, java.awt.BorderLayout.CENTER);

        pageStatistics.setBackground(new java.awt.Color(204, 204, 204));
        pageStatistics.setColumns(80);
        pageStatistics.setRows(2);
        pageStatistics.setText("Select item to display its statistics");
        pageStatistics.setBorder(new javax.swing.border.TitledBorder("Page statistics:"));
        treeTab.add(pageStatistics, java.awt.BorderLayout.SOUTH);

        centerPane.addTab("Search Tree", treeTab);

        messageTab.setBackground(new java.awt.Color(204, 204, 204));
        messageTab.setBorder(new javax.swing.border.EtchedBorder());
        messageTab.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        messageArea.setColumns(100);
        messageArea.setRows(5);
        messageTab.setViewportView(messageArea);

        centerPane.addTab("Messages", messageTab);

        getContentPane().add(centerPane, java.awt.BorderLayout.CENTER);

        statusLabel.setText("Inactive");
        getContentPane().add(statusLabel, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void searchTreeSelectionChange(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_searchTreeSelectionChange
        // TODO add your handling code here:
        TreePath path = searchTree.getSelectionPath();
        if(path == null)
            return;
        DefaultMutableTreeNode node = (DefaultMutableTreeNode)path.getLastPathComponent();
        UrlTreeNode data = (UrlTreeNode)node.getUserObject();
        if(data != null && data instanceof UrlTreeNode)
        {
         String kstr = data.getKeywords();
         pageStatistics.setText("Keywords found : "+kstr+"\n");
         pageStatistics.append(data.getNodeStats());
        }
        else
         pageStatistics.setText("");
        
    }//GEN-LAST:event_searchTreeSelectionChange

    private void viewButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewButtonActionPerformed
        // TODO add your handling code here:
     try{
      TreePath path = searchTree.getSelectionPath();
       if(path == null)
            return;
       DefaultMutableTreeNode node = (DefaultMutableTreeNode)path.getLastPathComponent();
       UrlTreeNode data = (UrlTreeNode)node.getUserObject();
        if(data instanceof UrlTreeNode)
        {
         String urlstr = data.getUrlString();   
         Runtime.getRuntime().exec("C:\\program files\\Internet Explorer\\iexplore.exe "+urlstr);
        }
        }
        catch(Exception e)
        {
         JOptionPane.showMessageDialog(this,"Could not launch Internet Explorer","Error",JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_viewButtonActionPerformed

    private void clearMessageButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearMessageButtonActionPerformed
        // TODO add your handling code here:
        messageArea.setText("");
    }//GEN-LAST:event_clearMessageButtonActionPerformed

    private void stopButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stopButtonActionPerformed
        // TODO add your handling code here:
        if(spidey != null)
           spidey.stopSearch();
    }//GEN-LAST:event_stopButtonActionPerformed

    private void startButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startButtonActionPerformed
        // TODO add your handling code here:
       int sitelimit =100,  depthlimit=100;
       
        try{
          sitelimit = Integer.parseInt(siteField.getText().trim()) ;
          depthlimit = Integer.parseInt(depthField.getText().trim()) ;
        }
        catch(NumberFormatException e)
        {
           errorLabel.setText("Invalid input for site limit or depth limit");
           return;
        }
 //
 // retrieve domains from combobox
 //
          Object selected[] = domainList.getSelectedValues();
          String[] domains = new String[selected.length];
          for(int i = 0; i < domains.length; i++)
            domains[i]= selected[i].toString();
 //
 // retrieve search strings
 //
          StringTokenizer keywordtokens = new StringTokenizer(keywordArea.getText(), "\n");
          String keywords[] = new String[keywordtokens.countTokens()];
          int i = 0;
          while(keywordtokens.hasMoreTokens())
            keywords[i++] = keywordtokens.nextToken();
  //
  // retrieve start site
  //
          String startsite = startSiteField.getText();
          if(startsite.length() <= 0)
          {
            errorLabel.setText("Starting web site cannot be blank!");
            return;
          }
     //
     // create and start the spider
     //
          errorLabel.setText("");
          pageStatistics.setText("Click on site to view its statistics");
          centerPane.setSelectedIndex(1);  // show the search tree tab
          spidey = new Spider(searchTree, messageArea, statusLabel, startsite, keywords, domains, sitelimit,depthlimit);
          spidey.start();
          
    }//GEN-LAST:event_startButtonActionPerformed

    private void exitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitButtonActionPerformed
        // TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_exitButtonActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * Main method.
     * @param args the command line arguments (not used)
     */
    public static void main(String args[]) {
        new SpiderControl().show();
    }
 /**
  * Verifier listener routine used to report bad data
  *  @param message error message
  *  @param jComponent component that caused the error.
  */
    public void invalidData(String message, JComponent jComponent) {
        errorLabel.setText(message);
        errorLabel.setForeground(Color.red);
        startButton.setEnabled(false);  // turn off the start button
        getToolkit().beep();
    }
  /**
  * Verifier listener routine used to report good data
  *  @param jComponent component that has tested ok
  */  
    public void validData(JComponent jComponent) {
        errorLabel.setText("  ");
        startButton.setEnabled(true);  // turn on the start button
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane centerPane;
    private javax.swing.JButton clearMessageButton;
    private javax.swing.JTextField depthField;
    private javax.swing.JLabel depthLabel;
    private javax.swing.JLabel domainLabel;
    private javax.swing.JList domainList;
    private javax.swing.JScrollPane domainPane;
    private javax.swing.JLabel errorLabel;
    private javax.swing.JButton exitButton;
    private javax.swing.JPanel formTab;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea keywordArea;
    private javax.swing.JLabel keywordLabel;
    private javax.swing.JScrollPane keywordPane;
    private javax.swing.JTextArea messageArea;
    private javax.swing.JScrollPane messageTab;
    private javax.swing.JTextArea pageStatistics;
    private javax.swing.JTree searchTree;
    private javax.swing.JScrollPane searchTreePane;
    private javax.swing.JTextField siteField;
    private javax.swing.JLabel siteLabel;
    private javax.swing.JButton startButton;
    private javax.swing.JTextField startSiteField;
    private javax.swing.JLabel startingLabel;
    private javax.swing.JLabel statusLabel;
    private javax.swing.JButton stopButton;
    private javax.swing.JPanel toolBar;
    private javax.swing.JPanel treeTab;
    private javax.swing.JButton viewButton;
    // End of variables declaration//GEN-END:variables
    /** spider object */
    Spider spidey = null;
}
